﻿-- Author      : Razielexx-Quel'Thalas
-- Create Date : 03/25/2016
local loop = 10;
local total = 0
local ft;
local scanning = false;
--local IDs = {789,986,985,984,983,982,823,848,846,847,851,850,849}

local IDs = {789,986,823,851}

StaticPopupDialogs["EXAMPLE_CTRA_READY"] = {
  text = "%s has performed a ready check.  Are you ready?",
  button1 = "Yes",
  button2 = "No",
  OnAccept = function()
      CT_RA_SendReady()
  end,
  OnCancel = function (_,reason)
      if reason == "timeout" or reason == "clicked" then
          CT_RA_SendNotReady()
      else
          -- "override" ...?
      end;
  end,
  sound = "levelup2",
  timeout = 30,
  whileDead = true,
  hideOnEscape = true,
}


function FrameSatchelFinder_OnLoad()
	ValidateForm();
	DEFAULT_CHAT_FRAME:AddMessage("SatchelFinder: Loaded!");
end

function CheckLKF()
	lblStatus:SetText("Searching...");
	local dungeonID = LFDQueueFrame.type
	if type(dungeonID) == "number" then
		for i = 1, LFG_ROLE_NUM_SHORTAGE_TYPES do
			for k,v in ipairs(IDs) do
				 	local eligible, forTank, forHeal, forDps, itemCount, money, xp = GetLFGRoleShortageRewards(v, i)
				 	   local name = GetLFGDungeonInfo(v);
				 	   	--DEFAULT_CHAT_FRAME:AddMessage(v .. " - " .. name .. " - " .. tostring(eligible)  .. " - " .. tostring(itemCount) );
						if eligible == true and itemCount ~= 0 then	
							if forTank == true and chkTank:GetChecked() == true then Ready("Tank", v) end
							if forHeal == true and chkHeal:GetChecked() == true then Ready("Heal", v) end
							if forDps == true and chkDps:GetChecked() == true then Ready("Dps", v) end
						end
					end
			end

	end
end

function btnSearch_OnClick()
	scanning = true;
	PlaySoundFile("Sound\\Interface\\LFG_Rewards.ogg");
	if not ft then
	ft = CreateFrame("Frame")
		ft:SetScript("OnUpdate", SetTimer)
	end
	DEFAULT_CHAT_FRAME:AddMessage("SatchelFinder: Searching...");
	lblStatus:SetText("Searching...");
	DisableChecks();
	DisableBtns();
end

function SetTimer(self,elapsed)
    total = total + elapsed
    if total >= loop and scanning == true then
		CheckLKF();
        total = 0
    end
end

function btnStop_OnClick()
	scanning = false;
	DEFAULT_CHAT_FRAME:AddMessage("SatchelFinder: Stoped...");
	lblStatus:SetText("");
	PlaySoundFile("Sound\\Interface\\LFG_Denied.ogg");
	EnabledChecks();
	EnabledBtns();
end

function Ready(Type, dungeonID)
   PlaySound("ReadyCheck");
   scanning = false;
   EnabledChecks();
   EnabledBtns();
   local name = GetLFGDungeonInfo(dungeonID)
   DEFAULT_CHAT_FRAME:AddMessage("SatchelFinder: Satchel find: " .. name .. " - " .. Type .. "!");
   lblStatus:SetText("Find for " .. Type .. "!");
end

function ValidateForm()
   if chkTank:GetChecked() == false and chkHeal:GetChecked() == false and chkDps:GetChecked() == false then
		DisableBtns();
		btnStop:Disable();
	else
		EnabledBtns();
   end
end

function EnabledChecks()
   chkTank:Enable();
   chkHeal:Enable();
   chkDps:Enable();
end

function DisableChecks()
   chkTank:Disable() ;
   chkHeal:Disable();
   chkDps:Disable() ;
end

function EnabledBtns()
   btnSearch:Enable();
   btnStop:Disable();
end

function DisableBtns()
   btnSearch:Disable();
   btnStop:Enable();
end

function Dialog()
	StaticPopup_Show("EXAMPLE_CTRA_READY", 1)
end
